﻿Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=1.80
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	Dim  tmrval As Long
End Sub

Sub Globals
    Private tmr1 As CountDownTimerView
	
    Private txtInput As EditText
	Private txtLog As EditText
	Private b_Stop As Button
	Private b_setTemp As Button
	Private b_setAlarm  As Button
	Private b_PreHeat  As Button
	Private b_StartCycle  As Button
	Private b_Stop  As Button
	Private lbl_Actual_Temp  As Label
	Private lbl_SetTemp  As Label
	Private txt_temp  As EditText
	Private txt_alarmTime  As EditText
	Public AStream As AsyncStreams
	'Private serial As Serial
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("pco")
	If FirstTime Then
		tmr1.Initialize("cd1_onTick")
	End If
End Sub


Public Sub NewMessage (msg As String)'called by BT manager when it gets new data
	LogMessage("nano", msg)
'	Dim firstc As Char       'these were planned to have a select case depending on the 1st char ie: 1 or 2 or 3 or 4....
'	Dim restc As String      'rest of string
'	firstc = msg.CharAt(0)   'get first char
'	restc = msg.SubString(1) 'get  'rest of string
Msgbox(msg,"message")
	txtLog.Text=msg          'update display
End Sub

Sub Activity_Resume
	UpdateState
End Sub

Public Sub UpdateState
	b_PreHeat.Enabled = Starter.Manager.ConnectionState 'enable preheat button when connected
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Starter.Manager.Disconnect
	End If
End Sub

'Sub txtInput_EnterPressed
'	If btnSend.Enabled = True Then btnSend_Click
'End Sub
'Sub btnSend_Click
'	Starter.Manager.SendMessage(txtInput.Text)
'	txtInput.SelectAll
'	txtInput.RequestFocus
'	LogMessage("j3", txtInput.Text)
'End Sub

Sub LogMessage(From As String, Msg As String)
	txtLog.Text = txtLog.Text & From & ": " & Msg & CRLF
	txtLog.SelectionStart = txtLog.Text.Length
End Sub
Public Sub SendMessage (msg As String)
	'AStream.Write(msg.GetBytes("utf8"))
	Starter.Manager.SendMessage(msg) ' Get here and to sendmessage in bluetooth manager with no errore but no data sent
End Sub

Sub b_Stop_Click
	tmr1.Time = 0
End Sub

Sub b_StartCycle_Click
	
	tmrval= txt_alarmTime.text * 60000
	tmr1.Time = tmrval
	tmr1.startCountDown
End Sub
Sub b_setTemp_Click
	Dim tmp As String
	tmp = txt_temp.Text
	SendMessage(tmp )
	'CallSub2("BluetoothManager","SendMessage",tmp)
	'wdata.Write(tmp.GetBytes("utf8"))
End Sub

Sub b_setAlarm_Click
	Dim tmp As String
	tmp = txt_alarmTime.Text
	SendMessage(tmp )
End Sub

Sub b_scan_Click
	
End Sub

Sub b_PreHeat_Click
	
End Sub

Sub b_Connect_Click
	
End Sub

Sub b_Allow_Click
	
End Sub

Sub ConvertMillisecondsToString(t As Long) As String
	Dim hours, minutes, seconds As Int
	hours = t / DateTime.TicksPerHour
	minutes = (t Mod DateTime.TicksPerHour) / DateTime.TicksPerMinute
	seconds = (t Mod DateTime.TicksPerMinute) / DateTime.TicksPerSecond
	Return $"$1.0{hours}:$2.0{minutes}:$2.0{seconds}"$
End Sub

Sub cd1_onTick(msToFinish As Long)
	
	Dim ts As String
	ts =ConvertMillisecondsToString(msToFinish)
	txt_alarmTime.Text = "Time left : " + ts
End Sub
Sub cd1_onFinish()
	Dim b As Beeper
	
	b.Initialize(300, 500) '300 milliseconds, 500 hz
	b.Beep
	Sleep(300)
	b.Beep
	Sleep(300)
	b.Beep
	Sleep(300)
	b.Beep
	Sleep(300)
End Sub
'Sub cd2_onTick(msToFinish As Long)
'	Log($"cd2_onTick(${msToFinish})"$)
'End Sub
'Sub cd2_onFinish()
'	Log($"cd2_onFinish()"$)
'End Sub